#include "stdio.h"

#include "USB2ST4_Conv.h"
#ifdef _WINDOWS
#include <windows.h>
#include "conio.h"
#else
#include <sys/time.h>
#include <unistd.h>
#include <termios.h>

int getch( ) {
struct termios oldt,
newt;
int ch;
tcgetattr( STDIN_FILENO, &oldt );
newt = oldt;
newt.c_lflag &= ~( ICANON | ECHO );
tcsetattr( STDIN_FILENO, TCSANOW, &newt );
ch = getchar();
tcsetattr( STDIN_FILENO, TCSANOW, &oldt );
return ch;
}
#define Sleep(a) usleep((a)*1000)
#endif
int  main()
{
	
	int USB2ST4_count = USB2ST4GetNum();  
	if(USB2ST4_count <= 0)
	{
		printf("no USB to ST4 converter connected, press any key to exit\n");
		getch();
		return -1;
	}
	else
		printf("attached converter :\n");
	

	for(int i = 0; i < USB2ST4_count; i++)
		printf("index %d\n",i);
	
	int USB2ST4Index = 0, iSelectedID;
	if (USB2ST4_count > 1)
	{
		printf("\nselect one by index\n");
		scanf("%d", & USB2ST4Index);
	}
	
	USB2ST4GetID(USB2ST4Index, &iSelectedID);

	if(USB2ST4Open(iSelectedID) != USB2ST4_SUCCESS)
	{
		printf("open error,are you root?,press any key to exit\n");
		getch();
		return -1;
	}

	
	if(iSelectedID < 0)
    	{	
       		printf("open error,are you root?,press any key to exit\n");
		getch();
		return -1;   
	 }
   	 else
	{     
		int iDuration = 100;
		printf("\ninput pulse duration in ms\n");
		scanf("%d", &iDuration);

		printf("\nPlease press up/down/left/right key to send pulse, type q to quit:\n");
		int ch;
#ifdef _WINDOWS
		const char Key_up = 72, Key_down = 80, Key_left = 75, Key_right = 77;
#else
		const char Key_up = 'A', Key_down = 'B', Key_left = 'D', Key_right = 'C';
#endif
		while( (ch=getch())!='q' )
		{
#ifdef _WINDOWS
			if (ch ==  0xE0)
			{
#else
			if (ch == '\033') 
			{ // if the first value is esc
				getch(); // skip the [			  
#endif
				switch(ch=getch())
				{
				case Key_up:  
					printf("UP\n"); 
					USB2ST4PulseGuide(iSelectedID, USB2ST4_NORTH, true);
					Sleep(iDuration);
					USB2ST4PulseGuide(iSelectedID, USB2ST4_NORTH, false);
					break;
				case Key_down: 
					printf("DOWN\n"); 
					USB2ST4PulseGuide(iSelectedID, USB2ST4_SOUTH, true);
					Sleep(iDuration);
					USB2ST4PulseGuide(iSelectedID, USB2ST4_SOUTH, false);
					break;
				case Key_left: 
					printf("LEFT\n"); 
					USB2ST4PulseGuide(iSelectedID, USB2ST4_WEST, true);
					Sleep(iDuration);
					USB2ST4PulseGuide(iSelectedID, USB2ST4_WEST, false);
					break;
				case Key_right:
					printf("RIGHT\n");
					USB2ST4PulseGuide(iSelectedID, USB2ST4_EAST, true);
					Sleep(iDuration);
					USB2ST4PulseGuide(iSelectedID, USB2ST4_EAST, false);
					break;
				default:
					break;
				}
			}

		}
		USB2ST4Close(iSelectedID);
		printf("main function over\n");
		return 1;
	}
}






